from hashlib import sha512


def hashB (m, bits):
	cantidad = (bits + 511) // 512
	mask = (1 << bits) - 1

	h = ''
	for n in range (cantidad):
		nHex = b'%x' % n
		h += sha512 (nHex + m).hexdigest ()

	h_int = int (h, 16)
	h_int = h_int & mask
	return h_int


# ----------------------------------------------------------------
if __name__ == '__main__':

	bits = 100
	m = b'abc'
	h = hashB (m, bits)

	print ('# m = ' + repr (m))
	print ('# hashB (m) = ' + repr (h))

